/*
 *	main.c
 *
 *	VvM
 *
 *	* Tue Aug 29 00:22:00 JST 2002 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

unsigned char BGM[] = {
#include "bgm.c"
};
unsigned char WARN[] = {
#include "warn.c"
};

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		30			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

/* OtBbN */
#define N_OBJS		64
#define CHR_CELL	0x90	/* 0x90`0x99,0xa0`0xa9 */
#define CHR_CURSOR	0x9a	/* 0x9a`0x9b,0xaa`0xab */
#define CHR_EXPL	0xb0	/* 0xb0`4x4Pʁ~N_EXPLS */
#define N_EXPLS		6	/* p^[̐ */

/*
 * ʃCAEgFicSsNZ炵܂j
 *
 *	@@OPQRSTUVWXOPQRST
 *	@{||||||||||||||||{
 *	Ob@@@@@@@@@@@@@@@@b<-4sNZ
 *	Pb@@@@@@b
 *	Qb@r@@o@b
 *	Rb@s@@`@b
 *	Sb@`@@m@b
 *	Tb@f@@d@b
 *	Ub@d@@k@b
 *	Vb@@@@@@b
 *	Wb@X@@X@b
 *	Xb@X@@X@b
 *	Ob@@@@@@b
 *	@{||||||||||||||||{
 */
#define FIELD_COL	 3
#define FIELD_ROW	 1
#define FIELD_COLS	 5
#define FIELD_ROWS	10
#define STAGE_COL	 1
#define STAGE_ROW	 2
#define PANEL_COL	14
#define PANEL_ROW	 2

/* Z^CvF
 *	0: [@]
 *	1: [_]
 *	2: [^]
 *	3: []
 *	4: []
 *
 * ڑF
 *	0: _
 *	   
 *	1: 
 *	   ^
 *	2: ^
 *	   
 *	3: 
 *	   _
 */
#define N_TYPES		5	/* Z^Cv̎ */
#define N_JOINS		4	/* ڑ̎ */
#define N_PEERS		3	/* ڑ̒̐ */

/* Z^Cvڑ}XN */
const char cell_join[N_TYPES] = {
	0,
	1 << 0 | 1 << 3,
	1 << 1 | 1 << 2,
	1 << 0 | 1 << 2,
	1 << 1 | 1 << 3,
};
/* ڑڑX,YItZbgEڑ */
const char join_peer[N_JOINS][N_PEERS][3] = {
	{{-1, 0,2},{-1,-1,3},{ 0,-1,1}},
	{{-1, 0,3},{-1, 1,2},{ 0, 1,0}},
	{{ 1, 0,0},{ 1,-1,1},{ 0,-1,3}},
	{{ 1, 0,1},{ 1, 1,0},{ 0, 1,2}},
};

/* Z */
typedef struct _CELL {
	char mark;	/* 0:ʏ/1:T/2: */
	char type;	/* Z^Cv */
	char next;	/* Ō̗\Z^Cv */
	char reserved;
} CELL;

/* Q[ZbV */
typedef struct _GAMEINFO {
	int stage;		/* Xe[W */
	int panel;		/* cpl */
	int interval;		/* ㏸C^[o */
	int interval_cnt;	/* ㏸C^[oJE^ */
	int cursor_col;		/* J[\       */
	int cursor_row;		/* J[\i(㑤) */
	int exchange_cnt;	/* JE^(0:łȂ) */
	int exchange_col;	/*        */
	int exchange_row;	/* i(㑤) */
	int erase_cnt;		/* ŃJE^(0:ŒłȂ) */
	int expl_cnt;		/* Aj[VJE^   */
	CELL field[FIELD_ROWS + 1][FIELD_COLS];
} GAMEINFO;

/* p */
#define CELLGEN_RATE	3	/* 1̊mŋłȂZɂȂ邩H */
#define FORCE_GEN	4	/* 󔒂ȉ̗񂪂Apl̂Ȃɋ邩Hi傫قǊȒPj */
#define PREDISP_TIME	SEC(2)	/* tB[h㏸O̓_Ŏ */
#define INIT_INTERVAL	SEC(5)	/* Xe[WJñC^[oۏؒl */
#define ERASE_COUNT	3	/* Ŏ(Aj[V犮H) */

/****************************************************************************
 *	ϐ
 ****************************************************************************/

int now;		/* O[o^C} */
int joy;		/* pbh */
int joy_rep[4];		/* pbh㉺ẼI[gs[gJE^ */

int stage_sel;		/* Xe[WI */
GAMEINFO gi;		/* Q[ZbV */

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
int demo();
void game();
int cell_gen(int need);
void line_gen();
void field_work();
int field_disp(int obj, int show_next);
int cursor_disp(int obj);
void erase_check();
int find();
#define FACT_LF	(1 << 0)
#define FACT_RI	(1 << 1)
int check(int col, int row, int join_src, int fact);

/****************************************************************************
 *	smain
 ****************************************************************************/

void
smain()
{
	/* B */
	srand(pceTimerGetCount());

	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(demo() != 0) break;
		game();
	}

	/* N[AbvB
	 * START+SELECTŏIꍇ̓N[Abv͍s܂B
	 */
	app_exit();
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʐݒB */
	thread_lock();
	pceWaveSetChAtt(0, 0);
	pceWaveSetChAtt(1, 0);
	pceWaveSetChAtt(2, 0);
	pceWaveSetChAtt(3, 0);
	thread_unlock();

	/* \ݒB */
	dispmode(1,	/* 1:XvCg\/0:\ */
		 1,	/* 1:eLXg\/0:\ */
		 0,	/* 1:OtBbN\/0:\ */
		 0,	/* 1:eLXgO/0:w */
		 0);	/* wiF(wʕ\Ȃ̂) */
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_STR	"PAUSE!"	/* PAUSEbZ[W */
#define PAUSE_LEN	6		/* PAUSEbZ[W */
#define PAUSE_X		5		/* \ʒu */
#define PAUSE_Y		5		/* \ʒu */

	static unsigned prev;
	       unsigned cur;
	int joy_old, trg, i;

	int pause;
	unsigned char save[PAUSE_LEN];

	pause = 0;
	for(;;) {
		/* [VSYNC҂B */
		if(prev == 0) prev = msec();
		do {
			cur = msec();
		} while((cur - prev) * FPS < 1000); /* (cur-prev)<(1000/FPS)̕ό` */
		prev = cur;

		/* pbhԎ擾B
		 * VvCuł́AgKI[gs[g̔ōsȂ΂܂B
		 */
		joy_old = joy;
		joy = pad() & 0x00ff;
		trg = (joy ^ joy_old) & joy;
		joy |= trg << 8;
		for(i = 0; i < 4; i++) { /* ㉺E(bit0`3)̂݃I[gs[g */
			if(joy & 1 << i) { /* PAD_*ONȂ  */
				joy_rep[i]++;  /* JEgAbv */
				if(joy_rep[i] >= SEC(0.33) && joy_rep[i] & 1) { /* 莞ԉÂA2t[ */
					joy |= 1 << (i + 8); /* gK */
				}
			} else {
				joy_rep[i] = 0; /* JE^NA */
			}
		}

		/* PAUSEB */
		if(joy & TRG_START) {
			thread_lock();	/* pclSprite*()gpɃXbh؂ւȂ悤 */
			pause ^= 1;	/* PAUSEԐ؂ւ */
			if(pause & 1) {	/* PAUSE IN */
				/* PAUSEbZ[W\̕ޔB */
				for(i = 0; i < PAUSE_LEN; i++) {
					save[i] = pclSpriteBGGetCharacter(0, PAUSE_X + i, PAUSE_Y);
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̕𕜋AB */
				for(i = 0; i < PAUSE_LEN; i++) {
					pclSpriteBGSetCharacter(0, PAUSE_X + i, PAUSE_Y, save[i]);
				}
			}
			thread_unlock();/* pclSprite*()gpÎŃXbh؂ւ */
		}
		if(!(pause & 1)) break;

		/* PAUSEbZ[W_ŕ\B */
		thread_lock();	/* pclSprite*()gpɃXbh؂ւȂ悤 */
		for(i = 0; i < PAUSE_LEN; i++) {
			pclSpriteBGSetCharacter(0, PAUSE_X + i, PAUSE_Y, pause & 2 ? PAUSE_STR[i] : 0);
		}
		pause ^= 2;
		thread_unlock();/* pclSprite*()gpÎŃXbh؂ւ */
	}
	now++;	/* O[o^C}XV */
}

/****************************************************************************
 *	demo
 ****************************************************************************/

int
demo()
{
	int result, mode_save, x, y;

	cls();
	fill(0, 0, DISP_X - 1, DISP_Y - 1, -1);

	/* \ݒۑB */
	thread_lock();
	mode_save = pclSpriteDispMode(INVALIDVAL);
	thread_unlock();

	/* ꎞIɃOtBbNʂ̂ݕ\B */
	dispmode(0,	/* 1:XvCg\/0:\ */
		 1,	/* 1:eLXg\/0:\ */
		 1,	/* 1:OtBbN\/0:\ */
		 0,	/* 1:eLXgO/0:w */
		 0);	/* wiF(wʕ\Ȃ̂) */

	/* ^Cg\B */
	x = (DISP_X - 5 * 6) / 2;
	y = 24;
	symbol(x, y, "SIMPLE", 0, 3);
	x = (DISP_X - 10 * 3) / 2;
	y = 36;
	symbol(x, y, "@M", 0, 3);

	for(;;) {
		schedule();

		/* Q[JnA܂͏IH */
		if(joy & TRG_A     ) { result =  0; sound(2); break; }
		if(joy & TRG_SELECT) { result = -1;           break; }

		/* Xe[WIB */
		if(stage_sel > 0      && joy & (TRG_LF | TRG_DN)) stage_sel--;
		if(stage_sel < 99 - 1 && joy & (TRG_RI | TRG_UP)) stage_sel++;
		locate(4,  7); siprintf("STAGE%3d", stage_sel + 1);

		/* vvg\B */
		locate(3,  9); printstr(now % SEC(0.75) < SEC(0.5) ? "[ A ] START" : "           ");
		locate(3, 10); printstr(now % SEC(0.75) < SEC(0.5) ? "[SEL] EXIT " : "           ");
	}

	/* \ݒ𕜌B */
	thread_lock();
	pclSpriteDispMode(mode_save);
	thread_unlock();

	return result;
}


/****************************************************************************
 *	game
 ****************************************************************************/

void
game()
{
	CELL* cell;
	int i, x, y, obj, col, row, gameover, bgm;

	/* ʏB */
	cls();
	thread_lock();
	pclSpriteBGSetPosition(0, 0, 4); /* ㉺Z^O */
	col = STAGE_COL;
	row = STAGE_ROW;
	pclSpriteBGSetCharacter(0, col, row++, 'S');
	pclSpriteBGSetCharacter(0, col, row++, 'T');
	pclSpriteBGSetCharacter(0, col, row++, 'A');
	pclSpriteBGSetCharacter(0, col, row++, 'G');
	pclSpriteBGSetCharacter(0, col, row++, 'E');
	col = PANEL_COL;
	row = PANEL_ROW;
	pclSpriteBGSetCharacter(0, col, row++, 'P');
	pclSpriteBGSetCharacter(0, col, row++, 'A');
	pclSpriteBGSetCharacter(0, col, row++, 'N');
	pclSpriteBGSetCharacter(0, col, row++, 'E');
	pclSpriteBGSetCharacter(0, col, row++, 'L');
	thread_unlock();

	/* Q[B */
	memset(&gi, 0, sizeof gi);
	gi.stage = stage_sel;

	for(;;) {
		/* Xe[WݒB */
		gi.stage++;
		if(gi.stage > 999) gi.stage = 999;
		gi.panel = 20 + gi.stage / 5 * 10; /* 5ʖ20,30,40,50,... */
		if(gi.panel > 999) gi.panel = 999;
		gi.interval = SEC(10) - SEC(10) * gi.stage / 30;   /* 1:10b0b:30    */
		if(gi.interval < SEC(0.5)) gi.interval = SEC(0.5); /* 0.5bԊuE */

		gi.interval_cnt = gi.interval - INIT_INTERVAL;
		if(gi.interval_cnt > 0) gi.interval_cnt = 0;
		gi.cursor_col = 2;
		gi.cursor_row = 4;
		gi.exchange_cnt = 0;
		gi.exchange_col = 0;
		gi.exchange_row = 0;
		gi.erase_cnt = 0;
		gi.expl_cnt = 0;
		memset(gi.field, 0, sizeof gi.field); /* mark,nextNA */
		cell = &gi.field[3][0]; /* Os͋󂯂 */
		for(row = 2; row < FIELD_ROWS; row++) { /* ʓ */
			for(col = 0; col < FIELD_COLS; col++) {
				cell->type = cell_gen(0);
				cell++;
			}
		}
		line_gen(); /* ŉi𐶐 */

		/* READY\B */
		gi.exchange_cnt = 0;
		for(i = 0; i < SEC(2); i++) {
			schedule();
			obj = 0;
			obj = field_disp(obj, 0);
			while(obj < N_OBJS) sppos(obj++, -8, -8);
			if(i % SEC(0.5) >= SEC(0.2)) {
				obj = N_OBJS - 5; /* K\ */
				x = (DISP_X - 8 * 5) / 2;
				y = (DISP_Y - 8 * 1) / 2;
				spdisp(obj++, x, y, 'R'); x += 8;
				spdisp(obj++, x, y, 'E'); x += 8;
				spdisp(obj++, x, y, 'A'); x += 8;
				spdisp(obj++, x, y, 'D'); x += 8;
				spdisp(obj++, x, y, 'Y'); x += 8;
			}
		}

		bgm = 0;
		for(;;) {
			schedule();

			/* ŏiɃpl邩ǂŁABGM؂ւB */
			cell = &gi.field[0][0];
			for(col = 0; col < FIELD_COLS; col++) {
				if(cell->type != 0 && cell->mark == 0) break; /* ŒZ͍ŏiɂĂ\Ȃ */
				cell++;
			}
			if(col == FIELD_COLS) { /* plȂ */
				if(bgm != 1) {
					pmdplay(BGM);
					bgm = 1;
				}
			} else { /* pl */
				if(bgm != 2) {
					pmdplay(WARN);
					bgm = 2;
				}
			}

			/* ŒȂ... */
			if(gi.erase_cnt != 0) {
				if(gi.expl_cnt < INT_MAX) gi.expl_cnt++; /* JE^i߂ */
				if(gi.expl_cnt >= FIELD_COLS * N_EXPLS) { /* ŃJE^i߂ */
					gi.expl_cnt = 0;
					if(gi.erase_cnt < INT_MAX) gi.erase_cnt++;
				}
				if(gi.erase_cnt > /*>=Ȃ!*/ ERASE_COUNT) { /* ŊH */
					sound(0);
					gi.erase_cnt = 0;
					cell = &gi.field[0][0];
					for(row = 0; row < FIELD_ROWS; row++) {
						for(col = 0; col < FIELD_COLS; col++) {
							if(cell->mark == 2) {
								cell->mark = 0;		/* }[N */
								cell->type = cell->next;/* \ZJグ */
								cell->next = 0;
								if(gi.panel > 0) gi.panel--; /* cpl炷 */
							}
							cell++;
						}
					}
					/* łȂ΁AɂȂubN܂B
					 * ȂAɂȂubN܂B
					 */
					if(gi.exchange_cnt == 0) gi.exchange_cnt = INT_MAX;
				}
				if(gi.panel == 0) break; /* Xe[WNA */

			/* ŒłȂ... */
			} else {
				if(gi.interval_cnt < INT_MAX) gi.interval_cnt++; /* ㏸C^[oi߂ */
				if(gi.interval_cnt >= gi.interval) {
					gi.interval_cnt = 0;
					cell = &gi.field[0][0];
					gameover = 0;
					for(row = 0; row < FIELD_ROWS; row++) {
						for(col = 0; col < FIELD_COLS; col++) {
							if(row == 0 && cell->type != 0) gameover = 1; /* ŏi˂ */
							*cell = *(cell + FIELD_COLS);
							cell++;
						}
					}
					if(gameover) goto GAMEOVER;
					line_gen(); /* op */
					/* J[\tčs܂B */
					if(gi.cursor_row > 0) gi.cursor_row--;
					/* łȂ΁AɂȂubN܂B
					 * ȂAɂȂubN܂B
					 */
					if(gi.exchange_cnt == 0) gi.exchange_cnt = INT_MAX;
				}
			}

			/* Ȃ... */
			if(gi.exchange_cnt != 0) {
				if(gi.exchange_cnt < INT_MAX) gi.exchange_cnt++; /* JE^i߂ */
				if(gi.exchange_cnt >= 8) { /* H */
					gi.exchange_cnt = 0;
					erase_check(); /* Ȃ蔻 */
				}
			}

			/* vC[B */
			field_work();

			/* \B */
			obj = 0;
			i = gi.interval - gi.interval_cnt < PREDISP_TIME && /* ㏸Ȃ */
			    now % SEC(0.34)/*=10*/ > SEC(0.1)/*=3*/;        /* ̒i_ŕ\ */
			obj = field_disp(obj, i);
			while(obj < N_OBJS) sppos(obj++, -8, -8);
			obj = N_OBJS - 4; /* K\ */
			obj = cursor_disp(obj);
			while(obj < N_OBJS) sppos(obj++, -8, -8);
		}
		pmdstop();

		/* NA\B */
		gi.exchange_cnt = 0;
		for(i = 0; i < SEC(3); i++) {
			schedule();
			obj = 0;
			obj = field_disp(obj, 0);
			while(obj < N_OBJS) sppos(obj++, -8, -8);
			obj = N_OBJS - 5; /* K\ */
			x = (DISP_X - 8 * 5) / 2;
			y = (DISP_Y - 8 * 1) / 2;
			spdisp(obj++, x, y, 'C'); x += 8;
			spdisp(obj++, x, y, 'L'); x += 8;
			spdisp(obj++, x, y, 'E'); x += 8;
			spdisp(obj++, x, y, 'A'); x += 8;
			spdisp(obj++, x, y, 'R'); x += 8;
		}
	}

GAMEOVER:
	pmdstop();
	sound(2);

	/* Q[I[o[\B */
	gi.exchange_cnt = 0;
	for(i = 0; i < SEC(3); i++) {
		schedule();
		obj = 0;
		obj = field_disp(obj, 0);
		while(obj < N_OBJS) sppos(obj++, -8, -8);
		obj = N_OBJS - 8; /* K\ */
		x = (DISP_X - 8 * 8) / 2;
		y = (DISP_Y - 8 * 1) / 2;
		spdisp(obj++, x, y, 'G'); x += 8;
		spdisp(obj++, x, y, 'A'); x += 8;
		spdisp(obj++, x, y, 'M'); x += 8;
		spdisp(obj++, x, y, 'E'); x += 8;
		spdisp(obj++, x, y, 'O'); x += 8;
		spdisp(obj++, x, y, 'V'); x += 8;
		spdisp(obj++, x, y, 'E'); x += 8;
		spdisp(obj++, x, y, 'R'); x += 8;
	}

	thread_lock();
	pclSpriteBGSetPosition(0, 0, 0); /* ㉺Z^O */
	thread_unlock();
}

/****************************************************************************
 *	cell_gen
 ****************************************************************************/

int
cell_gen(int need)
{
	int rate, type;

	rate = need ? 1/*Ko*/ : CELLGEN_RATE;
	type = (rand() / 3) % ((N_TYPES - 1) * rate);
	type = type < (N_TYPES - 1) ? type + 1 : 0/*Z*/;

	return type;
}

/****************************************************************************
 *	line_gen
 ****************************************************************************/

void
line_gen()
{
	CELL* cell;
	int col, row;
	int cnt[FIELD_COLS], cnt_max;

	cell = &gi.field[0][0];

	/* e̋łȂZ𐔂܂B */
	memset(cnt, 0, sizeof cnt);
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			if(cell->type != 0) cnt[col]++;
			cell++;
		}
	}
	/* cell͍ŉs̍[wĂ܂B */

	/* ԑ̐擾܂B */
	cnt_max = 0;
	for(col = 0; col < FIELD_COLS; col++) {
		if(cnt[col] > cnt_max) cnt_max = cnt[col];
	}

	/* oZ𐶐܂B */
	/* cell͍ŉs̍[wĂ܂B */
	for(col = 0; col < FIELD_COLS; col++) {
		/* 󔒂HȂ񂪈łA
		 * ẐȂɂ͕KZ𐶐܂B
		 */
		cell->type = cell_gen(cnt_max >= FIELD_ROWS - FORCE_GEN && cnt[col] == 0);
		cell++;
	}
}

/****************************************************************************
 *	field_work
 ****************************************************************************/

void
field_work()
{
	CELL *cell1, *cell2;
	int type1, type2, prev_col, prev_row;

	/* J[\ړB */
	prev_col = gi.cursor_col;
	prev_row = gi.cursor_row;
	if(joy & TRG_LF && gi.cursor_col > 0             ) gi.cursor_col--;
	if(joy & TRG_RI && gi.cursor_col < FIELD_COLS - 1) gi.cursor_col++;
	if(joy & TRG_UP && gi.cursor_row > 0             ) gi.cursor_row--;
	if(joy & TRG_DN && gi.cursor_row < FIELD_ROWS - 2) gi.cursor_row++;
	if(gi.cursor_col != prev_col || gi.cursor_row != prev_row) sound(3);

	/* B */
	if(joy & TRG_A) {
		sound(1);
		cell1 = &gi.field[gi.cursor_row + 0][gi.cursor_col];
		cell2 = &gi.field[gi.cursor_row + 1][gi.cursor_col];
		type1 = cell1->mark == 2 ? cell1->next : cell1->type;
		type2 = cell2->mark == 2 ? cell2->next : cell2->type;
		if(cell1->mark == 2) { cell1->next = type2; } else { cell1->type = type2; }
		if(cell2->mark == 2) { cell2->next = type1; } else { cell2->type = type1; }
		/* ɌȂA܂݂̌ɂȂ蔻s܂B */
		if(gi.exchange_cnt != 0) erase_check();
		/* Aj[VJnB */
		gi.exchange_cnt = 1;
		gi.exchange_col = gi.cursor_col;
		gi.exchange_row = gi.cursor_row;
	}

	/* Aj[VLZB */
	if(joy & TRG_B) {
		sound(1);
		if(gi.erase_cnt != 0) { /* ŒȂAŃAj[VLZ */
			gi.erase_cnt = INT_MAX;
		} else {                /* ŒłȂ΁Aɏ㏸ */
			gi.interval_cnt = INT_MAX;
		}
	}
}

/****************************************************************************
 *	field_disp
 ****************************************************************************/

int
field_disp(int obj, int show_next)
{
	CELL* cell;
	int x, y, dx, dy, col, row, chr;

	/* Z\B */
	cell = &gi.field[0][0];
	for(row = 0, y = FIELD_ROW; row < FIELD_ROWS + 1; row++, y += 1) {
		for(col = 0, x = FIELD_COL; col < FIELD_COLS; col++, x += 2) {
			dx = 0;
			dy = 0;
			if(row == FIELD_ROWS && !show_next) {
				thread_lock();
				pclSpriteBGSetCharacter(0, x + 0, FIELD_ROW + row, 0);
				pclSpriteBGSetCharacter(0, x + 1, FIELD_ROW + row, 0);
				thread_unlock();
			} else {
				/* ΏۃZH */
				if(gi.exchange_cnt != 0 && gi.exchange_col == col) {
					if(gi.exchange_row == row + 0) { /* Z̏̒i */
						dx = gi.exchange_cnt <= 4 ? gi.exchange_cnt : 8 - gi.exchange_cnt;
						dy = 8 - gi.exchange_cnt;
					} else if(gi.exchange_row == row - 1) { /* Z̉̒i */
						dx = -(gi.exchange_cnt <= 4 ? gi.exchange_cnt : 8 - gi.exchange_cnt);
						dy = gi.exchange_cnt - 8;
					}
				}
				/* {Z`B */
				chr = CHR_CELL + cell->type * 2;
				if(cell->mark == 2) chr += 0x10; /* ŎFύX */
				if(cell->mark != 2 && (dx != 0 || dy != 0)) { /* ̒ʏZ */
					thread_lock();
					pclSpriteBGSetCharacter(0, x + 0, FIELD_ROW + row, 0);
					pclSpriteBGSetCharacter(0, x + 1, FIELD_ROW + row, 0);
					thread_unlock();
					spdisp(obj++, (x + 0) * 8 + dx, y * 8 - 4 + dy, chr + 0);
					spdisp(obj++, (x + 1) * 8 + dx, y * 8 - 4 + dy, chr + 1);
				} else { /* łȂʏZA܂͏Ŋ{Z */
					thread_lock();
					pclSpriteBGSetCharacter(0, x + 0, FIELD_ROW + row, chr + 0);
					pclSpriteBGSetCharacter(0, x + 1, FIELD_ROW + row, chr + 1);
					thread_unlock();
				}
				/* \Z`B */
				if(cell->mark == 2 && (dx != 0 || dy != 0 || cell->next != 0)) { /* Aj[V̗͋\Z\ */
					chr = CHR_CELL + cell->next * 2;
					spdisp(obj++, (x + 0) * 8 + dx - 2, y * 8 - 4 + dy - 2, chr + 0);
					spdisp(obj++, (x + 1) * 8 + dx - 2, y * 8 - 4 + dy - 2, chr + 1);
				}
			}
			cell++;
		}
	}

	/* \B */
	if(gi.erase_cnt != 0) {
		col = gi.expl_cnt / N_EXPLS;
		chr = gi.expl_cnt % N_EXPLS;
		chr = CHR_EXPL + chr * 2;
		if(0 <= col && col <= FIELD_COLS - 1) { /* ΂Ȃ͂Ô */
			for(row = 0; row < FIELD_ROWS; row++) {
				cell = &gi.field[row][col];
				if(cell->mark != 2) continue;
				x = FIELD_COL + col * 2;
				y = FIELD_ROW + row    ;
				spdisp(obj++, (x + 0) * 8, (y + 0) * 8 - 8, chr + 0x00);
				spdisp(obj++, (x + 1) * 8, (y + 0) * 8 - 8, chr + 0x01);
				spdisp(obj++, (x + 0) * 8, (y + 1) * 8 - 8, chr + 0x10);
				spdisp(obj++, (x + 1) * 8, (y + 1) * 8 - 8, chr + 0x11);
			}
		}
	}

	/* \B */
	thread_lock();
	col = STAGE_COL;
	row = STAGE_ROW + 5;
	chr = gi.stage >= 100 ? '0' + gi.stage / 100 % 10 : 0;
	pclSpriteBGSetCharacter(0, col, row++, chr);
	chr = gi.stage >=  10 ? '0' + gi.stage /  10 % 10 : 0;
	pclSpriteBGSetCharacter(0, col, row++, chr);
	chr =                   '0' + gi.stage       % 10    ;
	pclSpriteBGSetCharacter(0, col, row++, chr);
	col = PANEL_COL;
	row = PANEL_ROW + 5;
	chr = gi.panel >= 100 ? '0' + gi.panel / 100 % 10 : 0;
	pclSpriteBGSetCharacter(0, col, row++, chr);
	chr = gi.panel >=  10 ? '0' + gi.panel /  10 % 10 : 0;
	pclSpriteBGSetCharacter(0, col, row++, chr);
	chr =                   '0' + gi.panel       % 10    ;
	pclSpriteBGSetCharacter(0, col, row++, chr);
	thread_unlock();

	return obj;
}

/****************************************************************************
 *	cursor_disp
 ****************************************************************************/

int
cursor_disp(int obj)
{
	CELL* cell;
	int x, y;

	/* Zɂ҂dȂꍇ́A\܂B */
	if(gi.exchange_cnt != 0 &&
	   gi.exchange_col == gi.cursor_col && gi.exchange_row == gi.cursor_row) return obj;

	/* 㑤 */
	cell = &gi.field[gi.cursor_row + 0][gi.cursor_col];
	x = (FIELD_COL + gi.cursor_col * 2) * 8    ;
	y = (FIELD_ROW + gi.cursor_row + 0) * 8 - 4;
	if(cell->mark == 2 && cell->next != 0) {
		x -= 2;
		y -= 2;
	}
	spdisp(obj++, x    , y, CHR_CURSOR + 0x00);
	spdisp(obj++, x + 8, y, CHR_CURSOR + 0x01);

	/*  */
	cell = &gi.field[gi.cursor_row + 1][gi.cursor_col];
	x = (FIELD_COL + gi.cursor_col * 2) * 8    ;
	y = (FIELD_ROW + gi.cursor_row + 1) * 8 - 4;
	if(cell->mark == 2 && cell->next != 0) {
		x -= 2;
		y -= 2;
	}
	spdisp(obj++, x    , y, CHR_CURSOR + 0x10);
	spdisp(obj++, x + 8, y, CHR_CURSOR + 0x11);

	return obj;
}

/****************************************************************************
 *	erase_check
 ****************************************************************************/

void
erase_check()
{
	CELL* cell;
	int col, row;

	if(find()) { /* ȂubN */
		sound(2);
		do { /* ȂubN... */
			cell = &gi.field[0][0];
			for(row = 0; row < FIELD_ROWS; row++) {
				for(col = 0; col < FIELD_COLS; col++) {
					if(cell->mark == 1) {
						cell->mark = 2; /* }[N */
					}
					cell++;
				}
			}
		} while(find()); /* ܂H */
		if(gi.erase_cnt == 0) {
			gi.erase_cnt = 1;
			gi.expl_cnt = 0; /* (Jn) */
		} else {
			gi.erase_cnt = 1;
			/* gi.expl_cnt = ̂܂ (p) */
		}
	}
}

/****************************************************************************
 *	find
 ****************************************************************************/

int
find()
{
	CELL *cell, *cell2;
	int col, row, type, join, peer;
	int col2, row2, type2, join2;

	/* ŃZɐڑJnʒuB */
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &gi.field[row][col];	/* ׂZ */
			if(cell->mark != 0) continue;	/* Ƀ}[NĂ΂ */
			type = cell->type;		/* ׂZ̃^Cv */
			for(join = 0; join < N_JOINS; join++) {				/* SĂ̐ڑɂ... */
				if(!(cell_join[type] & 1 << join)) continue;		/* ̐ڑĂȂΔ΂ */
				for(peer = 0; peer < N_PEERS; peer++) {			/* ̐ڑ̑SĂ̑ɂ...  */
					col2  = join_peer[join][peer][0] + col;		/* ̈ʒu             */
					row2  = join_peer[join][peer][1] + row;
					join2 = join_peer[join][peer][2];		/* ɗvڑ */
					if(col2 < 0 || FIELD_COLS - 1 < col2) continue;	/* ̈ʒuʊOȂ΂ */
					if(row2 < 0 || FIELD_ROWS - 1 < row2) continue;
					cell2 = &gi.field[row2][col2];			/* ̃Z */
					if(cell2->mark != 2) continue;			/* ̃ZŒłȂΔ΂ */
					type2 = cell2->type;				/* ̃Z^Cv */
					if(!(cell_join[type2] & 1 << join2)) continue;	/* ̃ZɐڑłȂΔ΂ */
					if(check(col, row, join, FACT_LF | FACT_RI)) {	/* M`(ŃZE[ɐڑ\) */
						return 1; /*  */
					}
				}
			}
		}
	}

	/* [̊JnʒuB */
	col = 0;
	for(row = 0; row < FIELD_ROWS; row++) {
		cell = &gi.field[row][col];			/* ׂZ */
		if(cell->mark != 0) continue;			/* Ƀ}[NĂ΂ */
		type = cell->type;				/* ׂZ̃^Cv */
		if(type == 0) continue;				/* ZȂ΂܂ */
		join = cell_join[type] & 1 << 0 ? 0 : 1;	/* ڑ͍ォ */
		if(check(col, row, join, FACT_RI)) {		/* M`(ŃZE[ɐڑ\) */
			return 1; /*  */
		}
	}

	/* E[̊JnʒuB */
	col = FIELD_COLS - 1;
	for(row = 0; row < FIELD_ROWS; row++) {
		cell = &gi.field[row][col];			/* ׂZ */
		if(cell->mark != 0) continue;			/* Ƀ}[NĂ΂ */
		type = cell->type;				/* ׂZ̃^Cv */
		if(type == 0) continue;				/* ZȂ΂܂ */
		join = cell_join[type] & 1 << 2 ? 2 : 3;	/* ڑ͉EォE */
		if(check(col, row, join, FACT_LF)) {		/* M`(ŃZ[ɐڑ\) */
			return 1; /*  */
		}
	}

	return 0; /* s */
}

/****************************************************************************
 *	check
 ****************************************************************************/

int
check(int col, int row, int join_src, int fact)
{
	CELL* cell;
	int type, join, peer;
	int col2, row2, join2;

	if(row < 0 || FIELD_ROWS - 1 < row) return 0;		/* ʊO */
	if(col < 0             ) return fact & FACT_LF ? 1 : 0;	/* ʍɐڑ\Ȃ琬AsȂ玸s */
	if(FIELD_COLS - 1 < col) return fact & FACT_RI ? 1 : 0;	/* ʉEɐڑ\Ȃ琬AsȂ玸s */

	cell = &gi.field[row][col];				/* Z擾 */
	if(cell->mark == 1) return 0;				/* ɒTȂ玸s */
	type = cell->type;					/* Z^Cv擾 */
	if(!(cell_join[type] & 1 << join_src)) return 0;	/* ڑsȂ玸s */
	if(cell->mark == 2) return 1;				/* ŒZȂ琬 */

	cell->mark = 1;						/* T}[N */
	for(join = 0; join < N_JOINS; join++) {
		if(join == join_src) continue;			/* ڑɂ͐i߂Ȃ */
		if(!(cell_join[type] & 1 << join)) continue;	/* ̐ڑĂȂ */
		for(peer = 0; peer < N_PEERS; peer++) {		/* ̐ڑ̑SĂ̑ɂ...  */
			col2  = join_peer[join][peer][0] + col;	/* ̈ʒu             */
			row2  = join_peer[join][peer][1] + row;
			join2 = join_peer[join][peer][2];	/* ɗvڑ */
			if(check(col2, row2, join2, fact)) return 1; /* ċA`FbNH */
		}
	}
	cell->mark = 0;						/* T}[N */
	return 0;						/* s */
}

